<?php
/*
Plugin Name: WP Stop Forum Spam
Plugin URI: http://wordpress.org/extend/plugins/wp-stop-forum-spam/
Description: With this plugin you can query <a href="http://www.stopforumspam.com/">http://www.stopforumspam.com/</a> and block spam!
Author: Salvatore Noschese - DarkWolf
Version: 0.2
Author URI: http://www.darkwolf.it/
*/

// Prevent Direct Access with homepage redirect
if (!defined("DB_NAME"))
{
	header('Location: http://'.$_SERVER['SERVER_NAME'].'/');
}

// Require for user and plugin
include_once(ABSPATH . "wp-includes/pluggable.php");
include_once(ABSPATH . "wp-admin/includes/plugin.php");

// file_get_contents control (is required)!!!
if ((@file_get_contents("http://www.stopforumspam.com/robots.txt")) === false)
{
	deactivate_plugins(plugin_basename(__FILE__));
	add_action("admin_notices", "no_file_get_contents");
	if (isset($_GET["activate"])) { unset($_GET["activate"]); }
	function no_file_get_contents()
	{
		echo "<div id=\"message\" class=\"error\" style=\"padding:15px\">Error: This plugin require <a href=\"http://php.net/manual/en/function.file-get-contents.php\" style=\"text-decoration:none\">\"file_get_contents\"</a> to work properly!!!</div>";
	}
}

// Start Add link on plugins page
function wp_stopforumspam_action_links($links)
{ 
	$support = '<a href="http://www.darkwolf.it/" title="DarkWolf">Support</a>';
	array_unshift($links, $support);
	return $links;
}
add_filter('plugin_action_links_'.plugin_basename(__FILE__).'', 'wp_stopforumspam_action_links');
function wp_stopforumspam_meta_links($links, $file)
{
	if ($file == plugin_basename(__FILE__))
	{
		$links[] = '<a href="http://www.darkwolf.it/donate-wp" title="Buy Me a Beer ;)">Donate :)</a>';
	}
	return $links;
}
add_filter('plugin_row_meta', 'wp_stopforumspam_meta_links', 10, 2);
// End Add link on plugins page

// Start change CSS for this plugin on admin plugins page
function wp_stopforumspam_plugin_style()
{
	global $pagenow;
	if ($pagenow == "plugins.php")
	{
		$icon_link = plugin_dir_url(__FILE__)."sps_ico.png";
		echo "<style type=\"text/css\">\n#wp-stop-forum-spam td.plugin-title strong {\n\tbackground: url(\"".$icon_link."\") no-repeat 130px 1px;\n}\n#wp-stop-forum-spam div.row-actions-visible {\n\tpadding-top: 15px;\n}\n#wp-stop-forum-spam div.plugin-version-author-uri {\n\tbackground-color: #EAEAEA;\n\tborder-radius: 5px;\n\tbox-shadow: 0 8px 6px -6px gray; \n\tfont-weight: bold; \n\tpadding: 7px; \n\tmargin-bottom: 12px;\n}\n</style>\n";
	}
}
add_action('admin_print_styles', 'wp_stopforumspam_plugin_style');
// End change CSS for this plugin on admin plugins page

// Warning if is present Altervista Optimizer!!!
If (is_plugin_active("altervista-optimizer/altervista-optimizer.php"))
{
	deactivate_plugins(plugin_basename(__FILE__));
	add_action("admin_notices", "found_altervista_optimizer");
	if (isset($_GET["activate"])) { unset($_GET["activate"]); }
	function found_altervista_optimizer()
	{
		echo "<div id=\"message\" class=\"error\" style=\"padding:15px\">Altervista users: This plugin isn't necessary and can't be enabled if you use AlterVista Optimizer (and/or if u have alterblog account)!</div>";
	}
}
	
// Only for guest (not logged user)
if (!is_user_logged_in())
{
	// Start query
	function wp_stopforumspam_check_query()
	{
		// Generate user ip
		function getRealIpAddr()
		{
			if (!empty($_SERVER["HTTP_CLIENT_IP"]))
			{
				$ip=$_SERVER["HTTP_CLIENT_IP"];
			}
				elseif (!empty($_SERVER["HTTP_X_FORWARDED_FOR"]))
			{
				$ip=$_SERVER["HTTP_X_FORWARDED_FOR"];
			}
				else
			{
				$ip=$_SERVER["REMOTE_ADDR"];
			}
			return $ip;
		}

		// Make link (also compatible with bbpress plugin)
		$user_mail = ( isset($_POST['email']) ) ? trim($_POST['email']) : null;
		If (is_plugin_active("bbpress/bbpress.php") && (get_post_type() == "forum" || get_post_type() == "topic" || get_post_type() == "reply"))
		{
			$user_mail = ( isset($_POST['bbp_anonymous_email']) ) ? trim($_POST['bbp_anonymous_email']) : null;
		}
		$user_ip = getRealIpAddr();
		$chklink = "http://www.stopforumspam.com/api?email=".urlencode($user_mail)."&ip=".urlencode($user_ip)."";
		$jsonlink = json_decode(file_get_contents($chklink."&f=json")); // Add json format

		// Check value via json
		$json_email = $jsonlink->email->appears;
		$json_ip = $jsonlink->ip->appears;

		// If Is found in database set var and run
		if ((($json_email) == 1) || (($json_ip) == 1))
		{
			// Start page body
			$title = "Blocked By \"WP Stop Forum Spam\" by DarkWolf!"; // Page Title
			$referer = ( isset($_SERVER["HTTP_REFERER"]) ) ? "Back: <a href=\"".$_SERVER["HTTP_REFERER"]."\" onclick=\"history.back();return false;\">".str_replace(home_url(), "*", $_SERVER["HTTP_REFERER"])."</a>" : null;
			ob_start();	var_dump($jsonlink); $var_result = ob_get_clean(); // Output json log
			$die_start = "<!-- WP Stop Form Spam: http://wordpress.org/extend/plugins/wp-stop-forum-spam/ --></p>\n<h3 style=\"line-height:1.8;margin-top:-20px\">\n\tBlocked by \"WP Stop Forum Spam\" (thanks to \"<a href=http://www.stopforumspam.com/>Stop Forum Spam</a>\")\n\t<br />\n\t";
			$die_end = "\n\tfound in database!\n</h3>\n<hr />\n<i><b>Json Decode Log: <a href=\"".htmlspecialchars($chklink)."\">(email: ".$user_mail." / ip: ".$user_ip.")</a></b></i>\n".$var_result."\n<hr />\n<div style=\"font-size:12px\">\n\t".$referer."\n</div>\n<p><!-- WP Stop Form Spam: http://wordpress.org/extend/plugins/wp-stop-forum-spam/ -->";

			// If exist email and ip
			if ((($json_email) == 1) && (($json_ip) == 1))
			{
				wp_die("".$die_start."Ip \"<font color=\"#f57900\">".$user_ip."</font>\" &amp; email \"<font color=\"#f57900\">".$user_mail."</font>\"".$die_end."", $title);
			}

			// If exist only email
			elseif ((($json_email) == 1) && (($json_ip) == 0))
			{
				wp_die("".$die_start."Email \"<font color=\"#f57900\">".$user_mail."</font>\"".$die_end."", $title);
			}

			// If exist only ip
			elseif ((($json_email) == 0) && (($json_ip) == 1))
			{
				wp_die("".$die_start."Ip \"<font color=\"#f57900\">".$user_ip."</font>\"".$die_end."", $title);
			}
		}
	}

	add_action("pre_comment_on_post", "wp_stopforumspam_check_query");
	// Check if bbpress plugin is active!
	If (is_plugin_active("bbpress/bbpress.php"))
	{
		add_action("bbp_new_reply_pre_extras", "wp_stopforumspam_check_query");
		add_action("bbp_new_topic_pre_extras", "wp_stopforumspam_check_query");
	}

}

?>